<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'record_eodct_rtnrep');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_REC_EODREP_CTRTN_ID',
							'PARAM_REC_EODREP_CTRTN_REC_EODREP_ID', 
							'PARAM_REC_EODREP_CTRTN_TRANSACTION', 
							'PARAM_REC_EODREP_CTRTN_SUBTOTAL', 
							'PARAM_REC_EODREP_CTRTN_DISCOUNT', 
							'PARAM_REC_EODREP_CTRTN_VATABLE', 
							'PARAM_REC_EODREP_CTRTN_VATEXEMPT', 
							'PARAM_REC_EODREP_CTRTN_NONVAT', 
							'PARAM_REC_EODREP_CTRTN_ZERORATED', 
							'PARAM_REC_EODREP_CTRTN_VAT', 
							'PARAM_REC_EODREP_CTRTN_VAT_LESS', 
							'PARAM_REC_EODREP_CTRTN_POINT', 
							'PARAM_REC_EODREP_CTRTN_STATUS'
							// , 'PARAM_REC_EODREP_CTRTN_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_EODREP_CTRTN_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODREP_CTRTN_ID', true);
			$PARAM_REC_EODREP_CTRTN_REC_EODREP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODREP_CTRTN_REC_EODREP_ID', true);
			$PARAM_REC_EODREP_CTRTN_TRANSACTION = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODREP_CTRTN_TRANSACTION', true);
			$PARAM_REC_EODREP_CTRTN_SUBTOTAL = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_SUBTOTAL', true);
			$PARAM_REC_EODREP_CTRTN_DISCOUNT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_DISCOUNT', true);
			$PARAM_REC_EODREP_CTRTN_VATABLE = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_VATABLE', true);
			$PARAM_REC_EODREP_CTRTN_VATEXEMPT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_VATEXEMPT', true);
			$PARAM_REC_EODREP_CTRTN_NONVAT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_NONVAT', true);
			$PARAM_REC_EODREP_CTRTN_ZERORATED = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_ZERORATED', true);
			$PARAM_REC_EODREP_CTRTN_VAT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_VAT', true);
			$PARAM_REC_EODREP_CTRTN_VAT_LESS = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_VAT_LESS', true);
			$PARAM_REC_EODREP_CTRTN_POINT = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODREP_CTRTN_POINT', true);
			$PARAM_REC_EODREP_CTRTN_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_EODREP_CTRTN_STATUS', true);
			
			//$PARAM_REC_EODREP_CTRTN_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_REC_EODREP_CTRTN_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_REC_EODREP_CTRTN_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_REC_EODREP_CTRTN_ID,
							$PARAM_REC_EODREP_CTRTN_REC_EODREP_ID, 
							$PARAM_REC_EODREP_CTRTN_TRANSACTION, 
							$PARAM_REC_EODREP_CTRTN_SUBTOTAL, 
							$PARAM_REC_EODREP_CTRTN_DISCOUNT, 
							$PARAM_REC_EODREP_CTRTN_VATABLE, 
							$PARAM_REC_EODREP_CTRTN_VATEXEMPT, 
							$PARAM_REC_EODREP_CTRTN_NONVAT, 
							$PARAM_REC_EODREP_CTRTN_ZERORATED, 
							$PARAM_REC_EODREP_CTRTN_VAT, 
							$PARAM_REC_EODREP_CTRTN_VAT_LESS, 
							$PARAM_REC_EODREP_CTRTN_POINT, 
							$PARAM_REC_EODREP_CTRTN_STATUS
							// ,$PARAM_REC_EODREP_CTRTN_ID_FILE['name']
					]
			);
			
				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_RECORD_EODCT_RTNREP::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_ID'] = $PARAM_REC_EODREP_CTRTN_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_REC_EODREP_ID'] = $PARAM_REC_EODREP_CTRTN_REC_EODREP_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_TRANSACTION'] = $PARAM_REC_EODREP_CTRTN_TRANSACTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_SUBTOTAL'] = $PARAM_REC_EODREP_CTRTN_SUBTOTAL[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_DISCOUNT'] = $PARAM_REC_EODREP_CTRTN_DISCOUNT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_VATABLE'] = $PARAM_REC_EODREP_CTRTN_VATABLE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_VATEXEMPT'] = $PARAM_REC_EODREP_CTRTN_VATEXEMPT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_NONVAT'] = $PARAM_REC_EODREP_CTRTN_NONVAT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_ZERORATED'] = $PARAM_REC_EODREP_CTRTN_ZERORATED[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_VAT'] = $PARAM_REC_EODREP_CTRTN_VAT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_VAT_LESS'] = $PARAM_REC_EODREP_CTRTN_VAT_LESS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_POINT'] = $PARAM_REC_EODREP_CTRTN_POINT[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODREP_CTRTN_STATUS'] = $PARAM_REC_EODREP_CTRTN_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_RECORD_EODCT_RTNREP::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_FILEDIR_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/eod_ctrtnrep');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/eod_ctrtnrep/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000));
					
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_REC_EODREP_CTRTN_ID_FILE['tmp_name'][$ARRAY_CTR],
							PHPSET::$ROOT . '/upload/priv/Record/eod_ctrtnrep/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000) . '/' . $DATA_SET[0]['INSERTED_ID'] . '.' .
							PHPVC_STR::VAR_LCASE(PathInfo($PARAM_REC_EODREP_CTRTN_ID_FILE['name'][$ARRAY_CTR], PATHINFO_EXTENSION))
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>